#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 DimGray
#property indicator_color2 DarkGray
#property indicator_color3 DimGray
#property indicator_color4 DarkGray

double g_ibuf_76[];
double g_ibuf_80[];
double g_ibuf_84[];
double g_ibuf_88[];
int gi_92 = 0;

int init() {
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID, 1, Purple);
   SetIndexBuffer(0, g_ibuf_76);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, 1, DarkGreen);
   SetIndexBuffer(1, g_ibuf_80);
   SetIndexStyle(2, DRAW_HISTOGRAM, STYLE_SOLID, 3, Purple);
   SetIndexBuffer(2, g_ibuf_84);
   SetIndexStyle(3, DRAW_HISTOGRAM, STYLE_SOLID, 3, DarkGreen);
   SetIndexBuffer(3, g_ibuf_88);
   SetIndexDrawBegin(0, 10);
   SetIndexDrawBegin(1, 10);
   SetIndexDrawBegin(2, 10);
   SetIndexDrawBegin(3, 10);
   SetIndexBuffer(0, g_ibuf_76);
   SetIndexBuffer(1, g_ibuf_80);
   SetIndexBuffer(2, g_ibuf_84);
   SetIndexBuffer(3, g_ibuf_88);
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   double ld_0;
   double ld_8;
   double ld_16;
   double ld_24;
   if (Bars <= 10) return (0);
   gi_92 = IndicatorCounted();
   if (gi_92 < 0) return (-1);
   if (gi_92 > 0) gi_92--;
   for (int li_32 = Bars - gi_92 - 1; li_32 >= 0; li_32--) {
      ld_0 = (g_ibuf_84[li_32 + 1] + (g_ibuf_88[li_32 + 1])) / 2.0;
      ld_24 = (Open[li_32] + High[li_32] + Low[li_32] + Close[li_32]) / 4.0;
      ld_8 = MathMax(High[li_32], MathMax(ld_0, ld_24));
      ld_16 = MathMin(Low[li_32], MathMin(ld_0, ld_24));
      if (ld_0 < ld_24) {
         g_ibuf_76[li_32] = ld_16;
         g_ibuf_80[li_32] = ld_8;
      } else {
         g_ibuf_76[li_32] = ld_8;
         g_ibuf_80[li_32] = ld_16;
      }
      g_ibuf_84[li_32] = ld_0;
      g_ibuf_88[li_32] = ld_24;
   }
   return (0);
}